<template>
  <v-dialog
    width="50%"
    height="auto"
    v-model="selectedValue"
    name="edit_client_receipt"
  >
    <v-card>
      <v-card-title class="light">Modifiko një mandat</v-card-title>
      <v-container>
        <v-row class="mx-2">
          <v-col cols="12">
            <v-select
              label="Arka / Banka *"
              v-model="request.cash_unit_id"
              :items="banks"
              item-value="id"
              item-text="unit_name"
              :readonly="readonly()"
            />
          </v-col>
        </v-row>
        <v-row class="mx-2">
          <v-col cols="12">
            <v-select
              label="Lloji*"
              v-model="request.document_type"
              :items="documentTypes"
              :readonly="readonly()"
            />
          </v-col>
        </v-row>
        <v-row class="mx-2">
          <v-col cols="6">
            <v-text-field
              label="Data*"
              type="date"
              v-model="request.date"
              :readonly="readonly()"
            />
          </v-col>
          <v-col cols="6">
            <v-text-field
              label="Vlera*"
              v-model="request.value"
              type="number"
              min="0"
              :readonly="readonly()"
            />
          </v-col>
        </v-row>
        <v-row class="mx-2">
          <v-col cols="6">
            <currency-select
              v-model="request.currency_id"
              @exchange-rate="event => (this.request.exchange_rate = event)"
              @currency_id="getCurrencyId"
              :readonly="readonly()"
            />
          </v-col>
          <v-col cols="6">
            <v-text-field
              label="Kursi"
              v-model="request.exchange_rate"
              :readonly="readonly()"
            />
          </v-col>
        </v-row>
        <v-row class="mx-2">
          <v-col cols="6">
            <v-text-field
              label="Shënime"
              v-model="request.notes"
              :readonly="readonly()"
            />
          </v-col>
        </v-row>
      </v-container>
      <v-card-actions>
        <f-confirm-btn
          label="Konfirmo kredit"
          @click="confirm"
          :disabled="loading"
          v-if="!readonly()"
        />
        <p class="confirmed" v-if="readonly()">
          Mandat i konfirmuar
        </p>
        <v-spacer />
        <f-cancel-btn @click="close" v-if="!readonly()" />
        <f-submit-btn
          @click="submit"
          :loading="loading"
          :disabled="loading"
          v-if="!readonly()"
        />
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>

<script lang="ts">
import { Component, Vue, Prop } from 'vue-property-decorator'
import api from '@/plugins/api'
import FSubmitBtn from '@/components/buttons/FSubmitBtn.vue'
import FConfirmBtn from '@/components/buttons/FConfirmBtn.vue'
import FCancelBtn from '@/components/buttons/FCancelBtn.vue'
import CurrencySelect from '@/components/general/CurrencySelect.vue'

@Component({
  components: { FCancelBtn, FConfirmBtn, FSubmitBtn, CurrencySelect },
})
export default class EditClientReceipt extends Vue {
  @Prop({ required: true }) value!: string
  @Prop({ type: Object }) receipt!: any

  request: any = {
    creditable_id: '',
    creditable_type: 'App\\Client',
    document_type: null,
    date: null,
    value: null,
    currency_id: null,
    exchange_rate: null,
    notes: null,
    cash_unit_id: null,
  }
  loading = false
  banks = []
  documentTypes?: Array<string> = ['MA', 'MAB', 'MAC']

  public get selectedValue() {
    return this.value
  }

  public set selectedValue(newValue: string) {
    this.$emit('input', newValue)
    this.$emit('change', newValue)
  }

  mounted() {
    this.fetchReceipt()
    this.fetchBanks()
  }

  close() {
    this.$emit('close')
  }

  fetchReceipt() {
    api()
      .get(`/api/account-management/receipts/${this.receipt.id}`)
      .then(response => {
        this.request = response.data.data[0]
      })
  }

  fetchBanks() {
    api()
      .get('/api/account-management/banks')
      .then(response => {
        this.banks = response.data.data
      })
      .finally(() => (this.loading = false))
  }
  getCurrencyId(id) {
    this.request.currency_id = id
  }

  submit() {
    this.loading = true
    api()
      .put(`/api/account-management/receipts/${this.receipt.id}`, this.request)
      .then(response => {
        alert(response.data.message)
        if (!(response && response.data && response.data.status === 0)) return
        this.$emit('refresh')
        this.$emit('close')
      })
      .catch(error => {
        alert(error.message)
      })
      .finally(() => {
        this.loading = false
      })
  }

  confirm() {
    api()
      .put(
        `/api/account-management/receipts/${this.receipt.id}/confirm`,
        this.request
      )
      .then(response => {
        alert(response.data.message)
        if (!(response && response.data && response.data.status === 0)) return
        this.close()
        this.$emit('refresh')
      })
      .catch(error => {
        alert(error.message)
      })
      .finally(() => {
        this.loading = false
      })
  }

  readonly() {
    return this.request.status_id === 16 || this.request.status_id === 1
  }
}
</script>
